import { createApp } from 'vue';
import App from './App';
import router, { setupRouter } from './router/index';
import dayjs from 'dayjs';
import { setupNaive } from './plugins';
import { setupStore } from './store';
import store from './storex';
import 'dayjs/locale/zh-cn';
import './styles/index.less';
import './utils/rem';

import { TUICore, TUIComponents } from './TUIKit';
// import { TUICallKit } from '@tencentcloud/call-uikit-vue'
import { TUINotification } from './TUIKit/TUIPlugin';

const SDKAppID = 1400805079; // Your SDKAppID
const secretKey =
  'c5f4ea6140128a36c842990446a2c89249ab886b5e1ea6893555aa635a0b3c30'; // Your secretKey
async function setupApp() {
  // app loading
  // const appLoading = createApp(AppLoading);
  // appLoading.mount('#appLoading');
  const app = createApp(App);

  setupNaive(app);

  // store plugin: pinia
  setupStore(app);

  setupRouter(app);

  dayjs.locale('zh-ch');

  // app.use(router);

  await router.isReady();

  const TUIKit = TUICore.init({
    SDKAppID
  });

  // TUIKit.config.i18n.provideMessage(locales)

  TUIKit.use(TUIComponents);
  // TUIKit.use(TUICallKit)
  TUIKit.use(TUINotification);
  // mount app
  app.use(store).use(TUIKit).mount('#app');
}

setupApp();

export { SDKAppID, secretKey };
